import { __assign } from "tslib";
import { analyzeStructure } from './structure';
import { NodeType } from './types/types';
export var cleanInitialState = function (state) {
    var output = __assign({}, state);
    var nodeTypes = analyzeStructure(state);
    Object.keys(nodeTypes).forEach(function (nodeName) {
        var nodeType = nodeTypes[nodeName];
        if (nodeType === NodeType.COLLECTION_NODE) {
            if (isCollectionNodeBlank(state[nodeName])) {
                output[nodeName] = {};
            }
        }
    });
    return output;
};
export var isCollectionNodeBlank = function (collectionNode) {
    var values = Object.values(collectionNode);
    if (values.length > 1) {
        return false;
    }
    var fields = Object.keys(values[0]);
    return fields.length === 1 && fields[0] === 'id';
};
