"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isCollectionNodeBlank = exports.cleanInitialState = void 0;
var tslib_1 = require("tslib");
var structure_1 = require("./structure");
var types_1 = require("./types/types");
var cleanInitialState = function (state) {
    var output = tslib_1.__assign({}, state);
    var nodeTypes = structure_1.analyzeStructure(state);
    Object.keys(nodeTypes).forEach(function (nodeName) {
        var nodeType = nodeTypes[nodeName];
        if (nodeType === types_1.NodeType.COLLECTION_NODE) {
            if (exports.isCollectionNodeBlank(state[nodeName])) {
                output[nodeName] = {};
            }
        }
    });
    return output;
};
exports.cleanInitialState = cleanInitialState;
var isCollectionNodeBlank = function (collectionNode) {
    var values = Object.values(collectionNode);
    if (values.length > 1) {
        return false;
    }
    var fields = Object.keys(values[0]);
    return fields.length === 1 && fields[0] === 'id';
};
exports.isCollectionNodeBlank = isCollectionNodeBlank;
